/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package circlehunterserverlive;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.text.Text;
import javafx.scene.text.Font;
import javafx.animation.Timeline;
import javafx.animation.KeyFrame;
import javafx.animation.Interpolator;
import javafx.scene.layout.VBox;
import java.util.HashMap;
import javafx.scene.Node;

def clientMapping = new HashMap();

function clientConnected(id : Integer) : Void{
  display("client {id} connected");
  def text = Text {
    content: "client {id}"
  }
  insert text into clientBox.content;
  clientMapping.put(id, text);
  broadcast("client {id} connected");
}

function clientDisconnected(id : Integer) : Void {
  display("client {id} disconnected");
  delete clientMapping.get(id) as Node from clientBox.content;
  broadcast("client {id} disconnected");
}

function messageReceived(id : Integer, msg : String) : Void {
  display("client {id} sent {msg}");
  broadcast("client {id} sent {msg}");
}


var server : Server = new Server(clientConnected, clientDisconnected, messageReceived);


function broadcast(msg : String) {
  server.broadcast(msg);
}


server.start(4000);

function display(msg : String) {

  println(msg);
  def text = Text {
    content: msg
  }

  insert text into stage.scene.content;
  Timeline {
    keyFrames:
    [
      KeyFrame {
        time: 3s
        values: text.y => stage.scene.height tween Interpolator.LINEAR
        action: function() {
          delete text from stage.scene.content;
        }

      }
      ]
  }.play();

}

var clientBox : VBox = VBox{
  }
/**
 * @author thomas
 */

def stage = Stage {
    title: "Application title"
    scene: Scene {
        width: 250
        height: 80
        content: [
          clientBox
        ]
    }
}